---
title: Video and audio players
slug: Plugins/Flash_to_HTML5/Video/Players
tags:
  - Ads
  - DRM
  - Flash
  - HTML
  - UI
  - Video
  - adaptive streaming
  - player
---
<p>{{PreviousMenuNext("Plugins/Flash_to_HTML5/Video/Distribution", "Plugins/Flash_to_HTML5/Video/Subtitles_captions", "Plugins/Flash_to_HTML5/Video")}}</p>

<p class="summary">There are a number of ways to play back web media depending on the scale of your needs and whether you need ad integration and digital rights management.</p>

<p>For media playback on the web, a spectrum of options is available inluding:</p>

<ul>
 <li>An embedded <font face="consolas, Liberation Mono, courier, monospace">media</font> element with default or custom user agent controls.</li>
 <li>Digital rights management using <a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions</a>.</li>
 <li>Open source or commercial players which provide ready made solutions for needs such as ads integration, and adaptive bitrate streaming.</li>
</ul>

<p>This page defines and discusses these options, all of which must be considered when deciding how to play back media on your web page.</p>

<h2 id="Considerations">Considerations</h2>

<h3 id="Media_Elements">Media Elements</h3>

<p>The most straightforward way to play back a media file is with the <a href="/en-US/docs/Web/HTML/Element/video"><code>&lt;video&gt;</code> element</a> or the <a href="/en-US/docs/Web/HTML/Element/audio">&lt;audio&gt; element</a>. This is suitable for basic playback, which generally means:</p>

<ul>
 <li>A single or small number of WebM or MP4 files.</li>
 <li>No advertising.</li>
 <li>You don't need adaptive bitrate (ABR) streaming or digital rights management (DRM).</li>
</ul>

<h3 id="User_Interface_Controls">User Interface Controls</h3>

<p>For user interface controls, you actually have a choice between custom player controls and native controls. Custom controls require <a href="https://developers.google.com/web/fundamentals/media/mobile-web-video-playback">more elements and custom scripts</a>. Adding native controls is as simple as adding the <code>controls</code> attribute to your <code>&lt;audio&gt;</code> or <code>&lt;video&gt;</code> element. For example:</p>

<pre class="brush: html"><code>&lt;video src="videofile.webm"</code> controls&gt;&lt;/video&gt;</pre>

<p>There are several things to consider when chosing. Native controls are optimized for the browser but are inconsistent between browsers. Custom controls allow you to build for accessibility, add your own branding, and keep the look and feel consistent between browsers.</p>

<p>See <a href="https://developers.google.com/web/fundamentals/media/mobile-web-video-playback">Mobile Web Video Playback</a> and <a href="/en-US/docs/Web/Apps/Fundamentals/Audio_and_video_delivery">Audio and video delivery</a> for more information on custom controls.</p>

<ul>
</ul>

<h3 id="Adaptive_Bitrate_Streaming">Adaptive Bitrate Streaming</h3>

<p>Adaptive Streaming offers multiple resolutions and bitrates to the user by having the player choose which quality level and bitrate to play based upon the user's bandwidth and other factors. This generally results in a significantly better user experience with less buffering and smoother playback leading to longer watch times. This is accomplished by using the <a href="/en-US/docs/Web/API/Media_Source_Extensions_API">Media Source Extensions API</a> to build to one of the adaptive bitrate standards, in other words, <a href="/en-US/docs/Web/API/Media_Source_Extensions_API#DASH">DASH</a> or <a href="https://developer.apple.com/streaming/">HLS</a>. Although it's possible to build your own player using these technologies, it is not recommended.</p>

<h3 id="Digital_Rights_Management">Digital Rights Management</h3>

<p>You may be happy sharing your content with anyone who wants it. Or maybe your content is also your livelihood, in which case you'll need <a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions (EME)</a> or a player that supports digital rights management (DRM). See <a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/DRM_and_authentication">DRM and authentication</a> for more details.</p>

<h3 id="Ads_Integration">Ads Integration</h3>

<p>Your player will need to integrate with ad SDKs such as, for example, <a href="https://developers.google.com/interactive-media-ads/docs/sdks/html5/">IMA SDK</a> or <a href="http://freewheel.tv/">Freewheel</a>. Either work with your ad partners directly or partner with a player company or an online video provider who has already done these integrations.</p>

<h2 id="Media_Players">Media Players</h2>

<p>There are both open source and commercial options. While open source solutions will allow you to implement media playback without a licensing fee, commercial vendors can help you with ads integration and DRM.</p>

<p>Open Source Players:</p>

<ul>
 <li><a href="https://github.com/google/shaka-player">Shaka Player</a></li>
 <li><a href="http://videojs.com/">videojs</a></li>
 <li><a href="https://github.com/video-dev/hls.js/tree/master">HLS.js</a></li>
</ul>

<p>Commercial Players</p>

<ul>
 <li><a href="https://www.brightcove.com/en/player">Brightcove</a></li>
 <li><a href="https://www.jwplayer.com/">JWPlayer</a></li>
 <li><a href="https://www.theoplayer.com/">THEOPlayer</a></li>
 <li><a href="https://corp.kaltura.com/">Kaltura</a></li>
</ul>
